// =============================================================================
// webks.de SCSS Mixins: Helpers
// Version: 0.4
// =============================================================================

@import '../_functions/functions_helper';

// =============================================================================
//  Layout
// =============================================================================

// TODO: By default we have the same values for v+h, so maybe check if they're equal, so we can reduce the amount of variables
// TODO: If we would make $direction optional we could use this also for position (left, top, ...)
// TODO: Determine if its better to make this two seperate mixins named "margin" & "padding" - much more intuitive?!

/// webks spacing mixin
///
/// The goal of this mixin is to have responsive spacings with css variables.
/// The repsonsiveness itself are not handled by this mixin, just change the values
/// of your css spacing variables by media queries.
///
/// Default spacing type ist MARGIN set $type: padding as parameter to get padding instead.
/// To use size bbreviations (xs, sm, ..) you have to define those as css variables:
/// --space-md: 1rem;
/// --space-v-md: 1rem;
/// --space-h-md: 1rem;
/// [...]
///
/// How to use:
/// ===========
/// Shorthand usage with size abbreviations:
/// - @include space(lg md);
///   ==> margin: (--var-space-v-lg) (--var-space-h-md);
/// Shorthand usage with custom sizes:
/// - @include space(10px 20rem);
///   ==> margin: 10px 20rem;
/// Shorthand padding:
/// - @include space(10px 20px, $type: padding);
///   ==> padding: 10px 20px;
/// Full example, padding with direction
/// - @include space(lg, bottom, padding);
///   ==> padding-bottom: (--var-space-v-lg);
///
/// @param {text/number (with unit)} $spacing
///   Size abreviations (xs, sm, ...) or number (10px, 20em, ...)
/// @param {integer (unitless)} $direction
///   The direction of the spacing (left, top, right, bottom), ignored if multiple values for $spacing set (shorthand)
/// @param {text} $type
///   Type of space (margin, padding)
/// @return `$type`-`$direction`: `$spacing`.


@mixin space($spacing: md, $direction: NULL, $type: margin){
  @if($direction != NULL) {
    @if(length($spacing) > 1) {
      // Shorthand synthax overrides/replaces direction
      $direction: NULL;
    }@else{
      $type: #{$type}-#{$direction};
    }
    $space-direction-type: NULL;
    @if($direction == top OR $direction == bottom){
      $space-direction-type: v;
    }@else if($direction == left OR $direction == right){
      $space-direction-type: h;
    }@else{
      @error "The direction argument of the space() mixin needs to be NULL (default), top, bottom, left or right. You could also simply use shorthand notation on the $spacing parameter, like you now from CSS margin and padding.";
    }
    // output with direction
    #{$type}: if(is-number($spacing), $spacing, var(unquote("--space-") + $space-direction-type + unquote("-") + $spacing));
  }@else{
    // output shorthand
    // TODO:
    // - 'auto' is also set on type padding - what is no allowed
    @if(length($spacing) == 1) {
      #{$type}: if(is-number($spacing), $spacing, var(unquote("--space-") + $spacing));
    }@else if(length($spacing) == 2){
      #{$type}: if((is-number(nth($spacing, 1)) or nth($spacing, 1) == 'auto'), nth($spacing, 1), var(unquote("--space-v-") + nth($spacing, 1)))
                if((is-number(nth($spacing, 2)) or nth($spacing, 2) == 'auto'), nth($spacing, 2), var(unquote("--space-h-") + nth($spacing, 2)));
    }@else if(length($spacing) == 3){
      #{$type}: if((is-number(nth($spacing, 1)) or nth($spacing, 1) == 'auto'), nth($spacing, 1), var(unquote("--space-v-") + nth($spacing, 1)))
                if((is-number(nth($spacing, 2)) or nth($spacing, 2) == 'auto'), nth($spacing, 2), var(unquote("--space-h-") + nth($spacing, 2)))
                if((is-number(nth($spacing, 3)) or nth($spacing, 3) == 'auto'), nth($spacing, 3), var(unquote("--space-v-") + nth($spacing, 3)));
    }@else if(length($spacing) == 4){
      #{$type}: if((is-number(nth($spacing, 1)) or nth($spacing, 1) == 'auto'), nth($spacing, 1), var(unquote("--space-v-") + nth($spacing, 1)))
                if((is-number(nth($spacing, 2)) or nth($spacing, 2) == 'auto'), nth($spacing, 2), var(unquote("--space-h-") + nth($spacing, 2)))
                if((is-number(nth($spacing, 3)) or nth($spacing, 3) == 'auto'), nth($spacing, 3), var(unquote("--space-v-") + nth($spacing, 3)))
                if((is-number(nth($spacing, 4)) or nth($spacing, 4) == 'auto'), nth($spacing, 4), var(unquote("--space-h-") + nth($spacing, 4)));
    }@else{
      @error "Your spacing list needs to be 1-4 values long, but is #{length($spacing)}";
    }
  }
}

// Stretch container to full viewport width (ignoring the parent container width)
@mixin viewport-width() {
  position: relative;
  left: 50%;
  margin-left: -50vw;
  width: 100vw;
}
@mixin undo-viewport-width() {
  position: static;
  margin-left: 0;
  width: auto;
}

// Reduce container width to max page width and center it (like Bootstraps .container).
@mixin page-width() {
  // @include flex-grid-column(12);
  // max-width:$grid-container;
  // margin-left:auto;
  // margin-right:auto;
  // width:100%; // fixes a bug where the container gets > 100% width on small devices
  @include xy-grid-container();
  &.grid-x {
    // if page container is also a grid container fix grid (the paddinga already comes
    // from the cell(s) inside and we dont have negative margins on the container)
    padding-left: 0;
    padding-right: 0;
  }
  // Nesting
  .page-width{
    padding-left:0;
    padding-right:0;
  }
}

// =============================================================================
//  Typo
// =============================================================================
// Get headersize from map (with breakpoints)
@mixin get-header-size($type) {
  font-size: rem-calc(map-get(map-get(map-get($header-styles, "small"), $type), "font-size") * 1px);
  @include breakpoint(medium) {
    font-size: rem-calc(map-get(map-get(map-get($header-styles, "medium"), $type), "font-size") * 1px);
  }
}

// Headings color
@mixin headings-color($color){
  h1, .h1,
  h2, .h2,
  h3, .h3,
  h4, .h4,
  h5, .h5{
    color: $color;
  }
}

// =============================================================================
//  Forms
// =============================================================================
// -- Force inline form
@mixin form-inline() {
  display: flex;
  * {
    margin: 0;
  }
  >* {
    display: flex;
    flex: 1 1 0;
    height: auto;
    min-width: 0;
    white-space: nowrap;
    input {
      max-width: none;
      height: auto;
    }
  }
  >.form-submit,
  >.form-actions {
    flex: 0 0 auto;
  }
}
